#include <mega16.h>
#include <delay.h>
#define column PORTB
#define ROW PORTA
int k,j=38,count,speed=20;

unsigned char arr[39]={0xff,0xff,0xff,0xff,0xff,0xFF,0xFF
,0xFF,0x9F,0x7F,0x7F,0xBF,0xDF,0x5F,0x4F,0xFF,0xC1,0xDF,0xCF,0xDF,0xCF,0xCB,0xCF,0x7F,0xBF,0xDF,0xFF,0xFF,0xCF,0xBF,0xBF,0xBF,0x9F,0xEF,0xE0,0xEF,0xE3,0xEB,0xEB};

interrupt [EXT_INT0] void ext_int0_isr(void)
{
 if (count>3){
 speed-=3;
 count=0; 
  }
}

// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)
{ 
 speed+=3;

}




interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{     
TCNT0=0;
count++;
if (count==speed) {
j--;
count=0;
};
}

                                         
void main(void)
{
DDRC=0xFF;
DDRA=0xFF;
DDRB=0xFF;
//timer0 time for shift
TIMSK=0x01;
TCCR0=0x05;
TCNT0=0;
//enable external intrrupt
GICR|=0xC0;
//enable entrrupt
#asm("sei")

while (1)
        {  
             PORTC=speed;
                
  
                for(k=0;k<=7;k++)
                {       
                            
                        delay_us(100); 
                        
                        column=k;
                         ROW=arr[k+j];
                        delay_us(100);


                } 
                if (j==0)
                j=38;
                

                  
        } 
}
